From 5f10f6b123c3aa94e19d0ef0e5887945b33d6e35 Mon Sep 17 00:00:00 2001
From: Sergey Fedorov <vital.had@gmail.com>
Date: Fri, 30 May 2025 01:07:10 +0800
Subject: [PATCH 1/9] hw/xquartz: replace sources with working 1.20-legacy

---
 hw/xquartz/GL/indirect.c                    |   2 +
 hw/xquartz/NSUserDefaults+XQuartzDefaults.h |  49 --
 hw/xquartz/NSUserDefaults+XQuartzDefaults.m | 148 ----
 hw/xquartz/X11Application.h                 |  63 +-
 hw/xquartz/X11Application.m                 | 888 ++++++++++++++++----
 hw/xquartz/X11Controller.h                  | 108 ++-
 hw/xquartz/X11Controller.m                  | 584 +++++++------
 hw/xquartz/applewm.c                        |   2 +-
 hw/xquartz/applewmExt.h                     |   6 +
 hw/xquartz/bundle/Info.plist.cpp            |  33 +-
 hw/xquartz/console_redirect.c               | 482 +++++++++++
 hw/xquartz/console_redirect.h               |  46 +
 hw/xquartz/darwin.c                         |  33 +
 hw/xquartz/darwinEvents.c                   |   3 -
 hw/xquartz/mach-startup/bundle-main.c       |  89 +-
 hw/xquartz/mach-startup/stub.c              | 126 ++-
 hw/xquartz/man/Xquartz.man                  |   2 +-
 hw/xquartz/pbproxy/app-main.m               |  40 +
 hw/xquartz/pbproxy/main.m                   |  66 +-
 hw/xquartz/pbproxy/pbproxy.h                |  11 +
 hw/xquartz/pbproxy/x-input.m                |  13 +-
 hw/xquartz/pbproxy/x-selection.m            |  73 +-
 hw/xquartz/quartz.c                         |  54 +-
 hw/xquartz/quartz.h                         |  11 -
 hw/xquartz/quartzCocoa.m                    |  66 ++
 hw/xquartz/quartzCommon.h                   |  55 ++
 hw/xquartz/quartzKeyboard.c                 | 182 +++-
 hw/xquartz/quartzRandR.c                    | 153 ++++
 hw/xquartz/quartzStartup.c                  |   4 +-
 hw/xquartz/xpr/appledristr.h                | 160 ++--
 hw/xquartz/xpr/dri.c                        |   2 +
 hw/xquartz/xpr/x-list.c                     |   3 +-
 hw/xquartz/xpr/xprAppleWM.c                 |  10 +
 hw/xquartz/xpr/xprEvent.c                   |  23 +-
 hw/xquartz/xpr/xprFrame.c                   |  65 +-
 hw/xquartz/xpr/xprScreen.c                  |  32 +-
 36 files changed, 2701 insertions(+), 986 deletions(-)
 delete mode 100644 hw/xquartz/NSUserDefaults+XQuartzDefaults.h
 delete mode 100644 hw/xquartz/NSUserDefaults+XQuartzDefaults.m
 create mode 100644 hw/xquartz/console_redirect.c
 create mode 100644 hw/xquartz/console_redirect.h
 create mode 100644 hw/xquartz/quartzCocoa.m
 create mode 100644 hw/xquartz/quartzCommon.h

diff --git a/hw/xquartz/GL/indirect.c b/hw/xquartz/GL/indirect.c
index a8ccfc8ee..6738946ff 100644
--- a/hw/xquartz/GL/indirect.c
+++ b/hw/xquartz/GL/indirect.c
@@ -35,6 +35,8 @@
 #include <dix-config.h>
 #endif
 
+#include <AvailabilityMacros.h>
+
 #include <dlfcn.h>
 
 #include <OpenGL/OpenGL.h>
diff --git a/hw/xquartz/X11Application.h b/hw/xquartz/X11Application.h
index 1ef98bee3..740a8070a 100644
--- a/hw/xquartz/X11Application.h
+++ b/hw/xquartz/X11Application.h
@@ -31,17 +31,36 @@
 #ifndef X11APPLICATION_H
 #define X11APPLICATION_H 1
 
-#include <X11/Xdefs.h>
-
 #if __OBJC__
 
 #import "X11Controller.h"
 
-@interface X11Application : NSApplication
+@interface X11Application : NSApplication {
+    X11Controller *_controller;
+
+    unsigned int _x_active : 1;
+}
+
+- (void)set_controller:controller;
+- (void)set_window_menu:(NSArray *)list;
 
-@property (nonatomic, readwrite, strong) X11Controller *controller;
-@property (nonatomic, readonly, assign) OSX_BOOL x_active;
+- (CFPropertyListRef)prefs_get_copy:(NSString *)key CF_RETURNS_RETAINED;
+- (int)prefs_get_integer:(NSString *)key default:(int)def;
+- (const char *)prefs_get_string:(NSString *)key default:(const char *)def;
+- (float)prefs_get_float:(NSString *)key default:(float)def;
+- (int)prefs_get_boolean:(NSString *)key default:(int)def;
+- (NSURL *)prefs_copy_url:(NSString *)key default:(NSURL *)def
+   NS_RETURNS_RETAINED;
+- (NSArray *)prefs_get_array:(NSString *)key;
+- (void)prefs_set_integer:(NSString *)key value:(int)value;
+- (void)prefs_set_float:(NSString *)key value:(float)value;
+- (void)prefs_set_boolean:(NSString *)key value:(int)value;
+- (void)prefs_set_array:(NSString *)key value:(NSArray *)value;
+- (void)prefs_set_string:(NSString *)key value:(NSString *)value;
+- (void)prefs_synchronize;
 
+- (X11Controller *)controller;
+- (OSX_BOOL)x_active;
 @end
 
 extern X11Application * X11App;
@@ -70,6 +89,40 @@ X11ApplicationCanEnterRandR(void);
 void
 X11ApplicationMain(int argc, char **argv, char **envp);
 
+#define PREFS_APPSMENU                "apps_menu"
+#define PREFS_FAKEBUTTONS             "enable_fake_buttons"
+#define PREFS_KEYEQUIVS               "enable_key_equivalents"
+#define PREFS_FULLSCREEN_HOTKEYS      "fullscreen_hotkeys"
+#define PREFS_FULLSCREEN_MENU         "fullscreen_menu"
+#define PREFS_SYNC_KEYMAP             "sync_keymap"
+#define PREFS_DEPTH                   "depth"
+#define PREFS_NO_AUTH                 "no_auth"
+#define PREFS_NO_TCP                  "nolisten_tcp"
+#define PREFS_DONE_XINIT_CHECK        "done_xinit_check"
+#define PREFS_NO_QUIT_ALERT           "no_quit_alert"
+#define PREFS_NO_RANDR_ALERT          "no_randr_alert"
+#define PREFS_OPTION_SENDS_ALT        "option_sends_alt"
+#define PREFS_FAKE_BUTTON2            "fake_button2"
+#define PREFS_FAKE_BUTTON3            "fake_button3"
+#define PREFS_APPKIT_MODIFIERS        "appkit_modifiers"
+#define PREFS_WINDOW_ITEM_MODIFIERS   "window_item_modifiers"
+#define PREFS_ROOTLESS                "rootless"
+#define PREFS_RENDER_EXTENSION        "enable_render_extension"
+#define PREFS_TEST_EXTENSIONS         "enable_test_extensions"
+#define PREFS_XP_OPTIONS              "xp_options"
+#define PREFS_LOGIN_SHELL             "login_shell"
+#define PREFS_UPDATE_FEED             "update_feed"
+#define PREFS_CLICK_THROUGH           "wm_click_through"
+#define PREFS_FFM                     "wm_ffm"
+#define PREFS_FOCUS_ON_NEW_WINDOW     "wm_focus_on_new_window"
+
+#define PREFS_SCROLL_IN_DEV_DIRECTION "scroll_in_device_direction"
 extern Bool XQuartzScrollInDeviceDirection;
 
+#define PREFS_SYNC_PB                "sync_pasteboard"
+#define PREFS_SYNC_PB_TO_CLIPBOARD   "sync_pasteboard_to_clipboard"
+#define PREFS_SYNC_PB_TO_PRIMARY     "sync_pasteboard_to_primary"
+#define PREFS_SYNC_CLIPBOARD_TO_PB   "sync_clipboard_to_pasteboard"
+#define PREFS_SYNC_PRIMARY_ON_SELECT "sync_primary_on_select"
+
 #endif /* X11APPLICATION_H */
